/*
 File: unq_strsym.cpp
 Date and Time: Fri Jan 30 18:55:27 2015 
*/
#include "unq_str.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_unq_str;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_unq_str::TH_unq_str(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_unq_str;
  NS_unq_str::Cunq_str Cunq_str_;// parallel-parser's parse table
#define ssPARSE_TABLE Cunq_str_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_unq_str::PROC_TH_unq_str(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_unq_str";
  static bool one_time(false);
  static NS_unq_str::Cunq_str* NS_unq_str_Cunq_str_(0);// parallel-parser's fsm table
  static Parser* NS_unq_str_Cunq_str_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_unq_str_Cunq_str_ = new NS_unq_str::Cunq_str();// parallel-parser's fsm table
    NS_unq_str_Cunq_str_parser = new Parser(*NS_unq_str_Cunq_str_,Caller_pp);
  }
 proc_parser = NS_unq_str_Cunq_str_parser;
#include "wproc_pp_core.h"
}
void 
Cunq_str::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Runq_str_:{
       Runq_str* sym;
     if(re->rule_ == 0){
       sym = new Runq_str(parser__);
       re->rule_ = sym;
     }else{
       sym = (Runq_str*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rchr_:{
       Rchr* sym;
     if(re->rule_ == 0){
       sym = new Rchr(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rchr*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rall_shift_:{
       Rall_shift* sym;
     if(re->rule_ == 0){
       sym = new Rall_shift(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rall_shift*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    default: return;
   }
}
